=begin
njeremy2 may 2012
=end

Sketchup::require 'sketchup'

#We retrive the face to bore a hole. We use the pushpull to the next face.
class Trouer

  #Initialisation
  def activate
    Sketchup.status_text = 'Cliquez sur une face pour la trouer'
  end
  
  #When we push left button, we check if the selected thing is a face, then we use "trouerFace"
  def onLButtonDown(flags, x, y, view)
    pickHelper = view.pick_helper
    pickHelper.do_pick(x, y)
    face = pickHelper.picked_face
    trouerFace(face) if face
  end
  
  # Make a hole on the nearest face selected.
  def trouerFace(face)
    # Shoot a ray in the opposite direction of the face.
    points = face.vertices.map { |v| v.position }
    source = average_point( points )
    ray = [ source, face.normal.reverse ]
    result = face.model.raytest( ray )
    puts 'ray'
    p result
    return false unless result
    # Verify the ray hit a face in the same context facing the opposite direction.
    point, path = result
    other_face = path.last
    p path
    puts 'other face'
    return false unless other_face.is_a?( Sketchup::Face )
    puts 'parent'
    return false unless face.parent == other_face.parent
    puts 'normal'
    return false unless other_face.normal.samedirection?( face.normal.reverse )
    puts 'PP!'
    distance = source.distance( point )
    face.pushpull( -distance )
  end
  
  def average_point(points)
    average = Geom::Point3d.new(0,0,0)
    return average if points.empty?
		number_of_points = points.length
    for pt in points
      average.x += pt.x
      average.y += pt.y
      average.z += pt.z
    end
    average.x = average.x / number_of_points
    average.y = average.y / number_of_points
    average.z = average.z / number_of_points
    average
	end
  
end # class Trouer


unless file_loaded?("testhole.rb")
  UI.menu("Plugins").add_item("njeremy2 Hole") {
    Sketchup.active_model.select_tool( Trouer.new )
  }
end
#---------------------------------------------------------------------------
file_loaded("testhole.rb")